#include <stdio.h>

#include <sys/types.h>
#include <sys/socket.h>

#include <gsloop.h>
#include <gsloop_types.h>

#include <gsloop_client.h>
#include <gsloop_con.h>
#include <gsloop_misc.h>


int gsloop_server_attach_client(struct gsloop	*gsloop,
				int		fd)
{
	int			fd_client;
	int			err;
	struct gsloop_client	*client;
	struct gsloop_server	*server;

	fd_client = accept(fd, NULL, 0);
	if (fd_client < 0) {
		perror("accept");
		return -1;
	}
				
	err = rn_prepare_fd_for_add(fd_client, getpid());
	err = rn_add(&gsloop->rn, fd_client, gsloop_client_cb, gsloop);

	client = &gsloop_con_alloc_and_add(gsloop, fd_client)->client;
	server = gsloop_con_get_server(gsloop, fd);
	
	client->data = server->client_data;
	client->fd = fd_client;
	client->close = server->client_close;
	client->cb = server->client_cb;

	/* FIXME: check for max allowed connections */

	dprintf(LEVEL_INFO, "[fd=%02d] [new_fd=%02d] new connection from client\n", fd, fd_client);

	return fd_client;
}


int gsloop_server_callback(rn_pollevent_t	*event)
{
	struct gsloop	*gsloop = event->client.data;
	int		fd = event->fd;
	int		err = 0;

	if (event->revents & POLLIN) {
		err = gsloop_server_attach_client(gsloop, fd);

		/* FIXME: err = gsloop_server_attach_client_hook(gsl, fd); */

	} else {
		switch (event->revents) {
		case POLLOUT:
			printf("POLLOUT\n");
			break;
		default:
			printf("Event: %d\n", event->revents);
			break;
		}
	}

	return err;
}
